#line 1 "C:/Documents and Settings/Administrator/Desktop/EmbeddedLab/MikroC/PIC18F2550/DigitalVolumeControl/VolumeControl.c"
#line 14 "C:/Documents and Settings/Administrator/Desktop/EmbeddedLab/MikroC/PIC18F2550/DigitalVolumeControl/VolumeControl.c"
 sbit LCD_RS at RC6_bit;
 sbit LCD_EN at RC7_bit;
 sbit LCD_D4 at RB4_bit;
 sbit LCD_D5 at RB5_bit;
 sbit LCD_D6 at RB6_bit;
 sbit LCD_D7 at RB7_bit;
 sbit LCD_RS_Direction at TRISC6_bit;
 sbit LCD_EN_Direction at TRISC7_bit;
 sbit LCD_D4_Direction at TRISB4_bit;
 sbit LCD_D5_Direction at TRISB5_bit;
 sbit LCD_D6_Direction at TRISB6_bit;
 sbit LCD_D7_Direction at TRISB7_bit;



sbit Reset at RB0_bit;
sbit Data at RB1_bit;
sbit Clock at RB2_bit;

sbit Up at RA0_bit;
sbit Down at RA1_bit;
sbit Select at RA2_bit;


unsigned short aa, bb, count1, count2, i, option;

char message1[] = "Lt:";
char message2[] = "Rt:";

void Select_Arrow(){
 switch (option) {
 case 0 : LCD_Out(1,1, "->");
 LCD_Out(2,1, "->");
 break;
 case 1 : LCD_Out(1,1, "->");
 LCD_Out(2,1, "  ");
 break;
 case 2 : LCD_Out(1,1, "  ");
 LCD_Out(2,1, "->");
 break;

 }
}

void Send_POT_Value(unsigned short num1, unsigned short num2){
unsigned int
unsigned short t, Flag, Mask;
Mask = 0x80;
Reset = 1;
Data = 1;
Clock = 1;
Delay_us(5);
Clock = 0;
 for (t=0; t<8; t++){
 Flag = num1 & Mask;
 if(Flag==0) Data = 0;
 else Data = 1;
 Clock = 1;
 Delay_us(5);
 Clock = 0;
 Mask = Mask >> 1;
 }
 Mask = 0x80;
 for (t=0; t<8; t++){
 Flag = num2 & Mask;
 if(Flag==0) Data = 0;
 else Data = 1;
 Clock = 1;
 Delay_us(5);
 Clock = 0;
 Mask = Mask >> 1;
 }
 Reset = 0;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,3,message1);
 Lcd_Out(2,3,message2);
 Select_Arrow();
 for (i=0; i<count1; i++) {
 LCD_Chr(1, 6+i,255);
 }
 for (i=0; i<count2; i++) {
 LCD_Chr(2, 6+i,255);
 }

}
void Debounce_Key(){
 Delay_ms(300);
}


void main() {
 CMCON = 0x07;
 ADCON1 = 0x0F;
 TRISA = 0xFF;
 TRISC = 0x00;
 TRISB = 0x00;
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,3,message1);
 Lcd_Out(2,3,message2);
 aa = 50;
 bb = 50;
 option = 0;
 count1 = 2;
 count2 = 2;
 Send_POT_Value(aa, bb);
 do {
 if (!Up) {
 Debounce_Key();
 switch (option) {
 case 0 : if (aa < 250) {
 aa = aa + 25;
 count1 = aa/25;
 }
 if (bb < 250) {
 bb = bb + 25;
 count2 = bb/25;
 }
 break;

 case 1 : if (aa < 250) {
 aa = aa + 25;
 count1 = aa/25;
 }
 break;
 case 2 : if (bb < 250) {
 bb = bb + 25;
 count2 = bb/25;
 }
 break;

 }

 Send_POT_Value(aa, bb);
 }

 if (!Down) {
 Debounce_Key();
 switch (option) {
 case 0 : if (aa > 0) {
 aa = aa - 25;
 count1 = aa/25;
 }
 if (bb > 0) {
 bb = bb - 25;
 count2 = bb/25;
 }
 break;

 case 1 : if (aa > 0) {
 aa = aa - 25;
 count1 = aa/25;
 }
 break;
 case 2 : if (bb > 0) {
 bb = bb - 25;
 count2 = bb/25;
 }
 break;

 }

 Send_POT_Value(aa, bb);
 }

 if (!Select) {
 Debounce_Key();
 option = option + 1;
 if (option > 2) option = 0;
 Select_Arrow();

 }


 } while (1);



}
